#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef vector<ll> vll;
typedef vector<int> vint;
typedef vector<vint> vvint;

int read() {
	int a = 0, b = 0; char c = getchar();
	while (c < '0' || c > '9') b ^= (c == '-'), c = getchar();
	while (c >= '0' && c <= '9') a = a * 10 - 48 + c, c = getchar();
	return b ? -a : a;
}

const int mod = 1000000007;
const int N = 100005;

struct dat {
	int xa, xb, ya, yb;
	void rd() {
		xa = read(), xb = read() + 1, ya = read(), yb = read() + 1;
	}
};
struct qwq {
	dat A;
	int op;
	ll s;
} a[N];

struct qaq {
	dat A; int v;
}; typedef vector<qaq> vqaq;

struct segt {
	int n;
	vint Y;
	vll tg, su;
	segt(vint xx) {
		Y = xx;
		n = Y.size();
		int m = 1; while (m < 2 * n) m <<= 1;
		tg = vll(m, 0), su = vll(m, 0);
	}
	void add(int l, int r, ll v, int p, int L, int R) {
		//cerr << p << ' ' << L << ' ' << R << ' ' << l << ' ' << r << ' ' << v << '\n';
		if (l <= L && R <= r) { tg[p] = (tg[p] + v) % mod, su[p] = (su[p] + v * (Y[R] - Y[L])) % mod; return; }
		int m = (L + R) >> 1;
		if (l < m) add(l, r, v, (p << 1), L, m);
		if (m < r) add(l, r, v, (p << 1) | 1, m, R);
		su[p] = (tg[p] * (Y[R] - Y[L]) + su[p << 1] + su[(p << 1) | 1]) % mod;
	}
	ll sum(int l, int r, int p, int L, int R) {
		if (l <= L && R <= r) return su[p];
		int m = (L + R) >> 1; ll s = tg[p] * (Y[min(r, R)] - Y[max(l, L)]);
		if (l < m) s += sum(l, r, (p << 1), L, m);
		if (m < r) s += sum(l, r, (p << 1) | 1, m, R);
		//cerr << "sum " << l << ' ' << r << ' ' << p << ' ' << L << ' ' << R << ' ' << s % mod << '\n';
		return s % mod;
	}
	void add(int l, int r, ll v) { add(l, r, v, 1, 0, n - 1); }
	ll sum(int l, int r) { return sum(l, r, 1, 0, n - 1); }
};

void sol(vqaq A, vqaq B) {
	if (!A.size() || !B.size()) return;
	vint X, Y;
	for (auto i : A) X.push_back(i.A.xa), X.push_back(i.A.xb), Y.push_back(i.A.ya), Y.push_back(i.A.yb);
	for (auto i : B) X.push_back(i.A.xa), X.push_back(i.A.xb), Y.push_back(i.A.ya), Y.push_back(i.A.yb);
	sort(X.begin(), X.end()), X.erase(unique(X.begin(), X.end()), X.end());
	sort(Y.begin(), Y.end()), Y.erase(unique(Y.begin(), Y.end()), Y.end());
	auto Q = [&](vint &X, int &x) { x = lower_bound(X.begin(), X.end(), x) - X.begin(); };
	for (auto &i : A) Q(X, i.A.xa), Q(X, i.A.xb), Q(Y, i.A.ya), Q(Y, i.A.yb);
	for (auto &i : B) Q(X, i.A.xa), Q(X, i.A.xb), Q(Y, i.A.ya), Q(Y, i.A.yb);
	int n = X.size(), m = Y.size();
	vvint AA(n), AB(n), BA(n), BB(n);
	for (int i = 0; i < A.size(); ++i) AA[A[i].A.xa].push_back(i), AB[A[i].A.xb].push_back(i);
	for (int i = 0; i < B.size(); ++i) BA[B[i].A.xa].push_back(i), BB[B[i].A.xb].push_back(i);
	segt Y1(Y), Y2(Y);
//	for (int i : X) cerr << i << ' '; cerr << "    "; for (int i : Y) cerr << i << ' '; cerr << '\n';
	//for (auto i : A) cerr << i.A.xa << ' ' << i.A.xb << ' ' << i.A.ya << ' ' << i.A.yb << "    "; cerr << '\n';
	//for (auto i : B) cerr << i.A.xa << ' ' << i.A.xb << ' ' << i.A.ya << ' ' << i.A.yb << "    "; cerr << '\n';
	for (int x = 0; x < n; ++x) {
		//cerr << x << " :x\n";
		auto add = [&](int yl, int yr, ll v) { Y1.add(yl, yr, v), Y2.add(yl, yr, v * X[x] % mod); };
		auto sum = [&](int yl, int yr) { return (Y1.sum(yl, yr) * X[x] - Y2.sum(yl, yr)) % mod; };
		for (int i : AA[x]) add(A[i].A.ya, A[i].A.yb, A[i].v);
		for (int i : AB[x]) add(A[i].A.ya, A[i].A.yb, mod - A[i].v);
		for (int i : BA[x]) a[B[i].v].s += (mod - sum(B[i].A.ya, B[i].A.yb));
		for (int i : BB[x]) a[B[i].v].s += sum(B[i].A.ya, B[i].A.yb);
	}
}

void solve(int l, int r) {
	if (l == r - 1) return;
	int m = (l + r) >> 1;
	solve(l, m), solve(m, r);
	vqaq A, B;
	for (int i = l; i < m; ++i) if (a[i].op == 1) A.push_back({a[i].A, a[i].s});
	for (int i = m; i < r; ++i) if (a[i].op == 2) B.push_back({a[i].A, i});
	sol(A, B);
}

int main() {
	int n = read();
	for (int i = 0; i < n; ++i) {
		a[i].op = read(), a[i].A.rd();
		if (a[i].op == 1) a[i].s = read();
	}
	solve(0, n);
	for (int i = 0; i < n; ++i) if (a[i].op == 2) cout << (a[i].s % mod + mod) % mod << '\n';
	return 0;
}

